<?php

namespace shippypro\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Close ServiceType
 * @subpackage Services
 */
class Close extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named CloseShipments
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \shippypro\StructType\CloseShipments $parameters
     * @return \shippypro\StructType\CloseShipmentsResponse|bool
     */
    public function CloseShipments(\shippypro\StructType\CloseShipments $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CloseShipments($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \shippypro\StructType\CloseShipmentsResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
